package com.ibm.j2ca.sample.twineball;

import java.io.InputStream;
import java.io.OutputStream;
import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import javax.resource.ResourceException;

import com.ibm.despi.Cursor;
import com.ibm.despi.DataExchangeFactory;
import com.ibm.despi.InputAccessor;
import com.ibm.despi.InputCursor;
import com.ibm.despi.OutputCursor;
import com.ibm.despi.exception.DESPIException;
import com.ibm.despi.exception.GetFailedException;
import com.ibm.j2ca.base.TypeFactory;
import com.ibm.j2ca.base.WBIStructuredRecord;
import com.ibm.j2ca.base.exceptions.RecordNotFoundException;
import com.ibm.j2ca.extension.metadata.Property;
import com.ibm.j2ca.extension.metadata.Type;
import com.ibm.j2ca.extension.metadata.exceptions.InvalidMetadataException;
import com.ibm.wbia.TwineBall.Server.TwineBallException;
import com.ibm.wbia.TwineBall.Server.TwineBallInterface;

public class TwineBallStructuredRecord extends WBIStructuredRecord {
	Map objectAnnotations;
	TwineBallInterface twineBallConnection;
	ObjectNaming objectNaming;
	ObjectSerializer objectSerializer;
	String objectName;
	String primaryKey;
	int index = 0;
	Vector keysForRetrieveAll;

	public Object clone()  {
		TwineBallStructuredRecord record = new TwineBallStructuredRecord();
		try{
		record.twineBallConnection = twineBallConnection;
		record.objectNaming = objectNaming;
		record.objectSerializer = objectSerializer;
		record.setEISRepresentation(this.getEISRepresentation());
		}catch(Exception e){
			throw new RuntimeException(e);
		}
		return record;
	}

	public OutputCursor getTopLevelOutputCursor(){
		return (OutputCursor)getTopLevelCursor();
	}
	

	public void close() {
		index =0;
		// TODO Auto-generated method stub
		
	}

	
	
	public boolean next(boolean copyValues) throws DESPIException {
		try{
			if(getOperationName().equalsIgnoreCase("Delete")){
				getTopLevelOutputCursor().startObject();
				Vector eisRepresentation = new Vector();
				eisRepresentation.add("primaryKey=" + getPrimaryKey());
				setEISRepresentation(eisRepresentation);
				objectSerializer.toCursor((Vector)this.getEISRepresentation(),getMetadata(),getTopLevelCursor());
				getTopLevelOutputCursor().completeObject();
			}
			else if(getOperationName().equalsIgnoreCase("RetrieveAll")){
				
				Type type = null;
				if (this.getMetadata() == null){
					 type = (Type) getTopLevelCursor().getMetadata();
				}else{
					type = this.getMetadata();
				}
				if(objectName == null){				
					Map annotations = type.getAnnotations(TwineBallConstants.METADATA_NAMESPACE);
					objectName = (String)annotations.get("ObjectName");
				}
					//eisRepresentation is the vector of fields to do the retrieve.
					if(keysForRetrieveAll == null){
						keysForRetrieveAll = twineBallConnection.findObjectKeysByContent(objectName,(Vector)this.getEISRepresentation());
					}
					String primaryKey = (String)keysForRetrieveAll.get(index);
					getTopLevelOutputCursor().startObject();
					Vector retrieved = twineBallConnection.getObject(objectName,primaryKey);
					objectSerializer.toCursor(retrieved,getMetadata(),getTopLevelCursor());
					retrieveChildren(getTopLevelCursor(), getMetadata(), primaryKey);
					getTopLevelOutputCursor().completeObject();
					index++;
					if (index >=(keysForRetrieveAll.size())){
						return false;
					}else{
						return true;
					}
			}else if(getOperationName().equalsIgnoreCase("OutboundDelete")){
				getTopLevelOutputCursor().startObject();
				getTopLevelOutputCursor().completeObject();
			}
			else {  //do a retrieve
				if(getEISRepresentation() == null){ //retrieve hasn't started.
					Type type = null;
					if (this.getMetadata() == null){
						 type = (Type) getTopLevelCursor().getMetadata();
					}else{
						type = this.getMetadata();
					}
					if(objectName == null){				
						Map annotations = type.getAnnotations(TwineBallConstants.METADATA_NAMESPACE);
						objectName = (String)annotations.get("ObjectName");
					}
					if (primaryKey == null){
						if(getTopLevelCursor() instanceof InputCursor){
								InputCursor cursor = (InputCursor)getTopLevelCursor();
								cursor.getNext();
								Iterator properties = type.getPropertyIterator();
								String keyProp = "Primarykey";
								while (properties.hasNext()) {
								    Property property = (Property) properties.next();
								    if(property.getName().equalsIgnoreCase("primarykey")) {
								        keyProp = property.getName();
								        break;
								    }
								}
								InputAccessor accessor = (InputAccessor)cursor.getAccessor(keyProp);
								primaryKey = accessor.getString();
							
						}
						
					}
					Vector eisRepresentation = twineBallConnection.getObject(objectName,primaryKey);
					this.setEISRepresentation(eisRepresentation);
				}
				if(getEISRepresentation() == null)
                                {       // not found
                                        // throw new DESPIException("Record not found:" + primaryKey);
                                        HashMap keys = new HashMap();
                                        keys.put("primaryKey", primaryKey);
					RecordNotFoundException RNFE = new RecordNotFoundException();
                                        RNFE.setPrimaryKeys(keys);
                                        throw RNFE;
				}
                                else if(((Vector)getEISRepresentation()).size() == 0)
                                {       // not found
                                        // throw new DESPIException("Record not found:" + primaryKey);
                                        HashMap keys = new HashMap();
                                        keys.put("primaryKey", primaryKey);
					RecordNotFoundException RNFE = new RecordNotFoundException();
                                        RNFE.setPrimaryKeys(keys);
                                        throw RNFE;
				}
				getTopLevelOutputCursor().startObject();
				objectSerializer.toCursor((Vector)getEISRepresentation(),getMetadata(),getTopLevelCursor());
				retrieveChildren(getTopLevelCursor(), getMetadata(), primaryKey);
				getTopLevelOutputCursor().completeObject();
			}
			
		}catch(Exception e){
			throw new DESPIException(e);
		}
		return false;
	}


	private void retrieveChildren(Cursor currentCursor, Type parentType, String parentKey) throws InvalidMetadataException, ResourceException, RemoteException, TwineBallException, DESPIException {
		Iterator propertyIterator = parentType.getPropertyIterator();
		while (propertyIterator.hasNext()){
			Property thisProperty = (Property)propertyIterator.next();
			if(thisProperty.isContainment()){
				Type childType = thisProperty.getType();
				String eisChildName = objectNaming.getEntityName(childType);
				String eisParentName = objectNaming.getEntityName(parentType);
				Vector childKeys = twineBallConnection.findChildKeys(eisParentName,parentKey,eisChildName);
				
				Iterator childKeyIterator = childKeys.iterator();
				while (childKeyIterator.hasNext()){
					String thisChildKey = (String)childKeyIterator.next();
					Vector childContents = twineBallConnection.getObject(eisChildName,thisChildKey);
					OutputCursor thisChildCursor = (OutputCursor)currentCursor.getChildCursor(thisProperty.getName());
					thisChildCursor.startObject();
					objectSerializer.toCursor(childContents,childType,thisChildCursor);
					thisChildCursor.completeObject();
					retrieveChildren(thisChildCursor,childType,thisChildKey);
				}
			}
		}
	}

	public void pushValue(String xpath) throws DESPIException {
	    
	}

	public TwineBallStructuredRecord() {
		super();
		// TODO Auto-generated constructor stub
	}



	public void setTwineBallConnection(TwineBallInterface twineBallConnection) {
		this.twineBallConnection = twineBallConnection;
	}
	public void initializeData() throws DESPIException{
		try{
			setEISRepresentation(objectSerializer.toNameValueVector(super.getMetadata(),super.getTopLevelCursor()));
		}catch(Exception e){
			throw new DESPIException(e);
		}
	}


	public void extract(String xpath) throws DESPIException {
		// TODO Auto-generated method stub
		
	}


	public InputStream getInputStream(String path) {
		// TODO Auto-generated method stub
		return null;
	}


	public boolean getNext(boolean copyValues) throws DESPIException {
		return next(copyValues);
	}



	public void initializeInput(DataExchangeFactory factory, Object[] metadata) throws DESPIException {
		super.initializeInput(factory, metadata);
		objectNaming = new ObjectNaming();
		objectSerializer = new ObjectSerializer(objectNaming);
		try{
			objectAnnotations = super.getMetadata().getAnnotations(TwineBallConstants.METADATA_NAMESPACE);
		}catch(Exception e){
			throw new DESPIException(e);
		}
	}


	public void initializeOutput(DataExchangeFactory factory, Object[] metadata) throws DESPIException {
		super.initializeOutput(factory, metadata);
		objectNaming = new ObjectNaming();
		objectSerializer = new ObjectSerializer(objectNaming);
		try{
			objectAnnotations = super.getMetadata().getAnnotations(TwineBallConstants.METADATA_NAMESPACE);
		}catch(Exception e){
			throw new DESPIException(e);
		}
		
	}

	public void setInputStream(InputStream inputStream, String path) {
		// TODO Auto-generated method stub
		
	}

	public void setOutputStream(OutputStream outputStream, String path) {
		// TODO Auto-generated method stub
		
	}

	public String getObjectName() {
		return objectName;
	}

	public void setObjectName(String objectName) {
		this.objectName = objectName;
	}

	public String getPrimaryKey() {
		return primaryKey;
	}

	public void setPrimaryKey(String primaryKey) {
		this.primaryKey = primaryKey;
	}




}
