/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.emd;

import com.ibm.j2ca.extension.emd.discovery.WBIMetadataDiscoveryImpl;
import com.ibm.j2ca.extension.emd.discovery.properties.WBISingleValuedPropertyImpl;
import commonj.connector.metadata.*;
import commonj.connector.metadata.discovery.properties.PropertyEvent;

/**
 * This defines the property for the maximum number of records that can be obtained in a query operation
 */
public class MaxRecordSingleProperty extends WBISingleValuedPropertyImpl {

	public MaxRecordSingleProperty(String propertyName, Class propertyType) throws MetadataException {
		super(propertyName, propertyType);
	}
	
	public void propertyChange(PropertyEvent event) {
		super.propertyChange(event);
		WBIMetadataDiscoveryImpl.getLogUtils().traceMethodEntrance(
				"MaxRecordsSingleProperty", "propertyChange()");
		if (event.getNewValue() != null) {
			if (event.getNewValue().equals("Inbound")) 
				this.setEnabled(false);
		else
			this.setEnabled(true);
		}
	}

}
