/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.emd.discovery;

import java.util.*;
import com.ibm.j2ca.extension.logging.LogUtils;
import com.ibm.j2ca.sample.twineball.emd.StringCaseChanger;
import com.ibm.wbia.TwineBall.Server.TwineBallInterface;
import commonj.connector.metadata.MetadataException;

/**
 * This is a convenience class that lets us construct a list of metadataObjects from a result set retrieved from our EIS.
 */
public class TwineBallMetadataObjectListFactory {
    static ArrayList getMetadataObjectsForObjectNames(Vector objectNames, TwineBallInterface twineBallConnection, LogUtils logUtils) throws MetadataException {
        ArrayList objectList = new ArrayList();
        Iterator objectIterator = objectNames.iterator();
        while (objectIterator.hasNext()) {
            String objectName = (String) objectIterator.next();
            TwineBallMetadataObject metadata = new TwineBallMetadataObject(twineBallConnection, objectName,  logUtils);
            metadata.setBOName(StringCaseChanger.toCamelCase(objectName));
            metadata.setLocation(metadata.getBOName());
            metadata.setDisplayName(objectName);
            TwineBallMetadataImportConfiguration conf = new TwineBallMetadataImportConfiguration(metadata);
            conf.setLocation(metadata.getLocation());
            metadata.setMetadataImportConfiguration(conf);
            objectList.add(metadata);
        }
        return objectList;
    }
}