/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.emd.discovery.connection;

import com.ibm.j2ca.extension.emd.discovery.WBIMetadataDiscoveryImpl;
import com.ibm.j2ca.extension.emd.discovery.properties.WBIPropertyGroupImpl;
import com.ibm.j2ca.extension.emd.discovery.properties.WBISingleValuedPropertyImpl;
import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.properties.PropertyGroup;

/**
 * This is a convenience class to share property setup among outbound and inbound.
 */
public class TwineBallConfigurationProperties {
    
    public static WBIPropertyGroupImpl getTwineBallConfigurationProperties() throws MetadataException {
        WBIPropertyGroupImpl propGroup = new WBIPropertyGroupImpl("Connection Properties");
        propGroup.setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("ConnectionProperties"));
        propGroup.setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("ConnectionProperties"));
        WBIPropertyGroupImpl serverInfo = new WBIPropertyGroupImpl("Server Information");
        serverInfo.setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("ServerInformation"));
        serverInfo.setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("ServerInformation"));
        WBISingleValuedPropertyImpl prop1 = new WBISingleValuedPropertyImpl("Url", String.class);
        prop1.setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("Url"));
        prop1.setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("Url"));
        prop1.setRequired(false);
        serverInfo.addProperty(prop1);
        prop1 = new WBISingleValuedPropertyImpl("Schema", String.class);
        prop1.setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("Schema"));
        prop1.setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("Schema"));
        prop1.setRequired(false);
        serverInfo.addProperty(prop1);
        WBIPropertyGroupImpl pg2 = new WBIPropertyGroupImpl("UserCredentials");
        pg2.setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("UserCredentials"));
        pg2.setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("UserCredentials"));
        WBISingleValuedPropertyImpl prop = new WBISingleValuedPropertyImpl("UserName", String.class);
        prop.setRequired(false);
        prop.setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("UserName"));
        prop.setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("UserName"));
        pg2.addProperty(prop);
        prop = new WBISingleValuedPropertyImpl("Password", String.class);
        prop.setRequired(false);
        prop.setSensitive(true); //show it as **** on display
        prop.setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("Password"));
        prop.setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("Password"));
        pg2.addProperty(prop);
        propGroup.addProperty(serverInfo);
        propGroup.addProperty(pg2);
        return propGroup;
    }
    /**
     * @param pg
     */
    public static String getLocation(PropertyGroup pg) {
        String location = "";
		WBISingleValuedPropertyImpl locationProp = (WBISingleValuedPropertyImpl) pg
		.getProperty("RelativePath");
		if (locationProp.getValue() != null && !locationProp.getValue().equals(""))
			location = location + (String) locationProp.getValue();
		if (!location.endsWith("/"))
			location = location + "/";
		return location;
    }
    
}