/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.emd.discovery.connection;

import com.ibm.j2ca.extension.emd.discovery.WBIAdapterTypeImpl;
import com.ibm.j2ca.extension.emd.discovery.WBIMetadataDiscoveryImpl;
import com.ibm.j2ca.extension.emd.discovery.connection.WBIInboundConnectionTypeImpl;
import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.connection.InboundConnectionConfiguration;

/**
 * This is the connectionType for inbound. 
 */
public class TwineBallInboundConnectionType extends WBIInboundConnectionTypeImpl {
    TwineBallInboundConnectionConfiguration conf = null;

    public TwineBallInboundConnectionType(WBIAdapterTypeImpl adapterType) throws MetadataException {
        super(adapterType);
        setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("ConnectionType"));
        setId("TwineBall");
        setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("ConnectionType"));
    }

    /*
     * (non-Javadoc)
     * 
     * @see commonj.connector.metadata.discovery.connection.InboundConnectionType#createInboundConnectionConfiguration()
     */
    public InboundConnectionConfiguration createInboundConnectionConfiguration() {
        try {
            if (conf == null)
                conf = new TwineBallInboundConnectionConfiguration(this);
        } catch (MetadataException e) {
           throw new RuntimeException(e);
        }
        return conf;
    }
}