/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.emd.discovery.connection;

import com.ibm.j2ca.extension.emd.discovery.WBIAdapterTypeImpl;
import com.ibm.j2ca.extension.emd.discovery.WBIMetadataDiscoveryImpl;
import com.ibm.j2ca.extension.emd.discovery.connection.WBIOutboundConnectionTypeImpl;
import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.connection.OutboundConnectionConfiguration;

/**
 * This is our outbound connection type.  
 */
public class TwineBallOutboundConnectionType extends WBIOutboundConnectionTypeImpl {
    TwineBallOutboundConnectionConfiguration conf = null;

    public TwineBallOutboundConnectionType(WBIAdapterTypeImpl adapterType) throws MetadataException {
        super(adapterType);
        setDescription(WBIMetadataDiscoveryImpl.getPropertyDescription("ConnectionType"));
        setDisplayName(WBIMetadataDiscoveryImpl.getPropertyName("ConnectionType"));
        setId("TwineBall");
    }

    /*
     * (non-Javadoc)
     * 
     * @see commonj.connector.metadata.discovery.connection.OutboundConnectionType#createOutboundConnectionConfiguration()
     */
    public OutboundConnectionConfiguration createOutboundConnectionConfiguration() {
        if (conf == null) { //so we can return the same config later
            try {
                conf = new TwineBallOutboundConnectionConfiguration(this);
            } catch (MetadataException e) {
                throw new RuntimeException(e);
            }
        }
        return conf;
    }
}