package com.ibm.j2ca.sample.twineball.emd.runtime;

import javax.resource.cci.Record;

import com.ibm.j2ca.base.WBIInteractionSpec;
import com.ibm.j2ca.base.internal.WPSServiceHelper;
import com.ibm.j2ca.extension.dataexchange.sdo.DEFactorySDO;
import com.ibm.j2ca.sample.twineball.TwineBallStructuredRecord;
import commonj.connector.runtime.DataBindingException;
import commonj.connector.runtime.RecordHolderDataBinding;
import commonj.sdo.DataObject;
import commonj.sdo.Property;

public abstract class TwineBallDataBinding implements RecordHolderDataBinding {

	TwineBallStructuredRecord record;
	DataObject inputBG = null;
	DataObject container = null;

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.RecordHolderDataBinding#getRecord()
	 */
	public Record getRecord() throws DataBindingException {
		// TODO Auto-generated method stub
		return record;
	}

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.RecordHolderDataBinding#setRecord(javax.resource.cci.Record)
	 */
	public void setRecord(Record arg0) throws DataBindingException {
		// TODO Auto-generated method stub
		this.record = (TwineBallStructuredRecord) arg0;
	}

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.DataBinding#getDataObject()
	 */
	public DataObject getDataObject() throws DataBindingException {
		// TODO Auto-generated method stub
		DataObject returnValue = null;
		
		try {
			DEFactorySDO binding = new DEFactorySDO();
			DataObject dataObject = null; 
			if (inputBG == null) {
				System.out.println(getNamespaceURI() + " " + getBusinessObjectName());
				if(record.getOperationName().equalsIgnoreCase(WBIInteractionSpec.RETRIEVE_ALL_OP)) {
				    container = WPSServiceHelper.createBusinessObject(getNamespaceURI(), getBusinessObjectName());
				    System.out.println("in retrieve all:  container " + container);
				    DataObject bg  = container.createDataObject(0);
				    Property property = WPSServiceHelper.getRootBusinessObjectProperty(bg.getType());
				    dataObject = bg.createDataObject(property);
					System.out.println("in retrieve all:  data object " + dataObject);
				}else{
					dataObject = WPSServiceHelper.createBusinessObject(getNamespaceURI(), getBusinessObjectName());
				}
				record.initializeOutput(binding, dataObject);
			}
			else
			{
				dataObject = inputBG.getDataObject(WPSServiceHelper.getRootBusinessObjectProperty(inputBG.getType()));
				record.initializeOutput(binding, dataObject);
			}

			//RetrieveAll, create a container SDO
        	if (record.getOperationName().equalsIgnoreCase(WBIInteractionSpec.RETRIEVE_ALL_OP)) {
        		int index=0;
        		while(record.getNext(true)) {
        			DataObject object = (DataObject) binding.getBoundObject();
        			System.out.println("in retrieve all, afterGetNext:  data object " + object);
        			DataObject BG = WPSServiceHelper.createDataObject(object.getType().getURI()+ "bg", object.getType().getName()+"BG");
        			BG.set(WPSServiceHelper.getRootBusinessObjectProperty(BG.getType()), object);
        			if(index == 0){
        				container.getList(0).set(index++,BG);
        			}else{
        				container.getList(0).add(BG);
        			}
        		}
        		return container;
        	}

			record.getNext(true); 
				DataObject object = (DataObject) binding.getBoundObject();
				DataObject bg = WPSServiceHelper.getBusinessGraph(dataObject);
				returnValue = WPSServiceHelper.createDataObject(bg.getType().getURI(), bg.getType().getName());
				returnValue.set(WPSServiceHelper.getRootBusinessObjectProperty(returnValue.getType()), object);
			
			System.out.println("binding object " + binding.getBoundObject());
		}
		catch (Exception e) {
			e.printStackTrace();
			throw new DataBindingException("Failed in population return object", e);
		}
		return returnValue;
	}

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.DataBinding#setDataObject(commonj.sdo.DataObject)
	 */
	public void setDataObject(DataObject arg0) throws DataBindingException {
		// TODO Auto-generated method stub
		try {
			record = new TwineBallStructuredRecord();
			inputBG = arg0;
			DEFactorySDO binding = new DEFactorySDO();
			DataObject dataObject = arg0.getDataObject(WPSServiceHelper.getRootBusinessObjectProperty(arg0.getType()));
			binding.setBoundObject(dataObject);
			record.initializeInput(binding, dataObject);
			}
			catch (Exception e) {
				throw new DataBindingException("Failed to initialize cursor", e); 
			}
	}
	
	public abstract String getNamespaceURI();

	public abstract String getBusinessObjectName();

}
