/*
 * Licensed Materials - Property of IBM
 * pidnumber
 * (C) Copyright IBM Corporation 2005. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.j2ca.sample.twineball.inbound;

import java.beans.IntrospectionException;
import java.beans.PropertyDescriptor;

import javax.resource.spi.InvalidPropertyException;
import javax.resource.spi.ResourceAdapter;

import com.ibm.j2ca.base.WBIActivationSpecForPooling;

/**
 * TwineBallResourceAdapter. This class contains all properties for inbound
 * communication.
 */
public class TwineBallActivationSpecWithXid extends WBIActivationSpecForPooling {
    String userName;
    String password;
    String url = "";
    String schema = "twineball";
    String eventTableName = "WBIA_EVENTS";
    ResourceAdapter resourceAdapter;

    /**
     * @return Returns the eventTableName.
     */
    public String getEventTableName() {
        return eventTableName;
    }

    /**
     * @param eventTableName
     *            The eventTableName to set.
     */
    public void setEventTableName(String eventTableName) {
        this.eventTableName = eventTableName;
    }

    /**
     * @return Returns the password.
     */
    public String getPassword() {
        return password;
    }

    /**
     * @param password
     *            The password to set.
     */
    public void setPassword(String password) {
        this.password = password;
    }

    /**
     * @return Returns the schema.
     */
    public String getSchema() {
        return schema;
    }

    /**
     * @param schema
     *            The schema to set.
     */
    public void setSchema(String schema) {
        this.schema = schema;
    }

    /**
     * @return Returns the url.
     */
    public String getUrl() {
        return url;
    }

    /**
     * @param url
     *            The url to set.
     */
    public void setUrl(String url) {
        this.url = url;
    }

    /**
     * @return Returns the userName.
     */
    public String getUserName() {
        return userName;
    }

    /**
     * @param userName
     *            The userName to set.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.resource.spi.ActivationSpec#validate()
     */
    public void validate() throws InvalidPropertyException {
        super.validate();
        try {
            if (eventTableName == null) {
                InvalidPropertyException e = new InvalidPropertyException();
                PropertyDescriptor propertyDescriptor = new PropertyDescriptor("eventTableName", TwineBallActivationSpecWithXid.class);
                e.setInvalidPropertyDescriptors(new PropertyDescriptor[] { propertyDescriptor });
                throw e;
            }
        } catch (IntrospectionException e) {
            throw new RuntimeException(e);
        }
    }
}