/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.outbound;

import javax.resource.ResourceException;
import javax.resource.cci.Interaction;
import com.ibm.j2ca.base.WBIConnection;
import com.ibm.j2ca.base.WBIManagedConnection;
import com.ibm.j2ca.sample.twineball.TwineBallResourceAdapter;
import com.ibm.wbia.TwineBall.Server.TwineBallInterface;

public class TwineBallConnection extends WBIConnection {
    public TwineBallConnection(TwineBallManagedConnection managedConnection) throws ResourceException {
        super(managedConnection);
    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.resource.cci.Connection#createInteraction()
     */
    public Interaction createInteraction() throws ResourceException {
        return new TwineBallInteraction(this);
    }

    public TwineBallInterface getEISConnection() throws ResourceException {
        TwineBallManagedConnection twineBallConnection = (TwineBallManagedConnection) this.getManagedConnection();
        return twineBallConnection.getEISConnection();
    }

    public TwineBallResourceAdapter getResourceAdapter() throws ResourceException {
        TwineBallManagedConnection twineBallConnection = (TwineBallManagedConnection) this.getManagedConnection();
        return (TwineBallResourceAdapter) twineBallConnection.getResourceAdapter();
    }
}