/*
 * Licensed Materials - Property of IBM
 * pidnumber
 * (C) Copyright IBM Corporation 2005. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.j2ca.sample.twineball.outbound;

import javax.resource.cci.ConnectionSpec;
import com.ibm.j2ca.base.WBIConnectionRequestInfo;

/**
 * @author Travis Nelson
 *  
 */
public class TwineBallConnectionSpec extends WBIConnectionRequestInfo implements ConnectionSpec {
    private boolean xa;

    /**
     * @return Returns the userid.
     */
    public String getUserid() {
        return super.getUserName();
    }

    /**
     * @param userid
     *            The userid to set.
     */
    public void setUserid(String userid) {
        super.setUserName(userid);
    }

    /**
     * @param userid
     * @param password
     * @param schema
     */
    public TwineBallConnectionSpec(String userid, String password) {
        setUserid(userid);
        setPassword(password);
        xa = false;
    }

    public TwineBallConnectionSpec(String userid, String password, boolean xa) {
        setUserid(userid);
        setPassword(password);
        this.xa = xa;
    }

    public TwineBallConnectionSpec() {
    }

    public Class getConnectionReqInfoClass() {
        return this.getClass();
    }

    /**
     * @return Returns the xa.
     */
    public boolean isXa() {
        return xa;
    }

    /**
     * @param xa
     *            The xa to set.
     */
    public void setXa(boolean xa) {
        this.xa = xa;
    }

    public Class getConnReqInfoClass() {
        return this.getClass();
    }
}