/*
 * Licensed Materials - Property of IBM
 * pidnumber
 * (C) Copyright IBM Corporation 2005. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.j2ca.sample.twineball.outbound;

import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.security.auth.Subject;
import com.ibm.j2ca.base.WBIConnectionRequestInfo;
import com.ibm.j2ca.base.WBIManagedConnectionFactory;
import com.ibm.j2ca.sample.twineball.TwineBallResourceAdapter;

/**
 * @author Travis Nelson
 *  
 */
public class TwineBallManagedConnectionFactory extends WBIManagedConnectionFactory {
    String url;
    String schema;

    /*
     * (non-Javadoc)
     * 
     * @see javax.resource.spi.ManagedConnectionFactory#createManagedConnection(javax.security.auth.Subject,
     *      javax.resource.spi.ConnectionRequestInfo)
     */
    public ManagedConnection createManagedConnection(Subject subject, ConnectionRequestInfo connectionRequestInfo) throws ResourceException {
        getLogUtils().traceMethodEntrance(TwineBallManagedConnectionFactory.class.getName(), "createManagedConnection()");
        TwineBallManagedConnection connection = new TwineBallManagedConnection(this, subject, (WBIConnectionRequestInfo) connectionRequestInfo, this.getResourceAdapter());
        getLogUtils().traceMethodExit(TwineBallManagedConnectionFactory.class.getName(), "createManagedConnection()");
        return connection;
    }

    /*
     * (non-Javadoc)
     * 
     * @see javax.resource.spi.ManagedConnectionFactory#createConnectionFactory(javax.resource.spi.ConnectionManager)
     */
    public Object createConnectionFactory(ConnectionManager connMgr) throws ResourceException {
        return new TwineBallConnectionFactory(connMgr, this);
    }

    /**
     * @return Returns the uRL.
     */
    public String getUrl() {
        return url;
    }

    /**
     * @param url
     *            The uRL to set.
     */
    public void setUrl(String url) {
        this.url = url;
    }

    /**
     * @return Returns the schema.
     */
    public String getSchema() {
        return schema;
    }

    /**
     * @param schema
     *            The schema to set.
     */
    public void setSchema(String schema) {
        this.schema = schema;
    }

    public TwineBallResourceAdapter getTwineBallResourceAdapter() {
        return (TwineBallResourceAdapter) super.getResourceAdapter();
    }
}