/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.outbound.commands;

import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.Vector;
import java.util.logging.Level;

import javax.resource.ResourceException;
import javax.resource.spi.CommException;

import com.ibm.despi.InputCursor;
import com.ibm.j2ca.extension.logging.LogUtilConstants;
import com.ibm.j2ca.extension.metadata.Type;
import com.ibm.wbia.TwineBall.Server.TwineBallException;
import com.ibm.wbia.TwineBall.Server.TwineBallInterface;

public class TwineBallCreateCommand extends TwineBallBaseCommand {
    /**
     * @param dataObject
     */
    public TwineBallCreateCommand() {
 
    }

    public void stripKey(Vector insertRecord){
    	Iterator i = insertRecord.iterator();
    	while(i.hasNext()){
    		String currentValue = (String)i.next();
    		if(currentValue.toUpperCase().startsWith("PRIMARYKEY")){
    			i.remove();
    		}
    	}
    	
    	
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.j2c.comparator.Command#execute(com.ibm.j2c.WBIRecord)
     */
    public void execute(InputCursor inputObject, Type metadata) throws ResourceException {
        getLogUtils().traceMethodEntrance(TwineBallCreateCommand.class.getName(), "execute()");
        String entity = objectNaming.getEntityName(metadata);
        TwineBallInterface connection = connection = (TwineBallInterface) this.getConnection();
        Vector insertRecord = objectSerializer.toNameValueVector(metadata, inputObject);
        stripKey(insertRecord);
        TwineBallBaseCommand parent = (TwineBallBaseCommand)this.getParentCommand();
       // if (parent == null || parent.getParentCommand() == null) {
        //    parent = null;
        //
        //}
    	if(parent != null){
        	linkChildToParent(parent, objectNaming.getEntityName(parent.getMetadata()), insertRecord);
        }
        String key = null;
        try {
            key = connection.insertObject(entity, insertRecord);
            setKey(key);
        } catch (RemoteException e) {
            getLogUtils().log(Level.SEVERE, LogUtilConstants.ADAPTER_RBUNDLE, TwineBallCreateCommand.class.getName(), "execute()", "1014", new Object[] {});
            throw new CommException(e);
        } catch (TwineBallException e) {
            getLogUtils().log(Level.SEVERE, LogUtilConstants.ADAPTER_RBUNDLE, TwineBallCreateCommand.class.getName(), "execute()", "1014", new Object[] {});
            throw new ResourceException(e);
        }
        //objectNaming.setKey(metadata, inputObject, key);
        insertRecord.add("primaryKey=" + key);
        this.setEisRepresentation(insertRecord);
        getLogUtils().traceMethodExit(TwineBallCreateCommand.class.getName(), "execute()");
    }

    /**
     * @param parentObject
     * @param objectNaming
     * @param insertRecord
     */
    private void linkChildToParent(TwineBallBaseCommand parentCommand, String parentName, Vector insertRecord) throws ResourceException {
            String parentKey = parentCommand.getKey();
            insertRecord.add("parentKey=" + parentKey);
            insertRecord.add("parentTable=" + parentName.toUpperCase());
    }
}