/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.outbound.commands;

import java.rmi.RemoteException;
import java.util.Vector;
import java.util.logging.Level;

import javax.resource.ResourceException;
import javax.resource.spi.CommException;

import com.ibm.despi.InputCursor;
import com.ibm.j2ca.extension.logging.LogUtilConstants;
import com.ibm.j2ca.extension.metadata.Type;
import com.ibm.wbia.TwineBall.Server.TwineBallException;
import com.ibm.wbia.TwineBall.Server.TwineBallInterface;

public class TwineBallDeleteCommand extends TwineBallBaseCommand {
    /**
     * @param dataObject
     */
    public TwineBallDeleteCommand() {
        super();
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.j2c.comparator.Command#execute(com.ibm.j2c.WBIRecord)
     */
    public void execute(InputCursor input, Type metadata) throws ResourceException {
        getLogUtils().traceMethodEntrance(TwineBallDeleteCommand.class.getName(), "execute()");
        String key = objectNaming.getKey(metadata,input);
        String entity = objectNaming.getEntityName(metadata);
        TwineBallInterface connection = connection = (TwineBallInterface) this.getConnection();
        try {
            connection.deleteObject(entity, key);
        } catch (RemoteException e) {
            this.getLogUtils().log(Level.SEVERE, LogUtilConstants.ADAPTER_RBUNDLE, TwineBallDeleteCommand.class.getName(), "execute()", "1015", new Object[] { key });
            throw new CommException(e);
        } catch (TwineBallException e) {
            throw new ResourceException(e);
        }
        this.setEisRepresentation(new Vector());
        getLogUtils().traceMethodExit(TwineBallDeleteCommand.class.getName(), "execute()");
    }
}