/*
 * Licensed Materials - Property of IBM
 * pidnumber
 * (C) Copyright IBM Corporation 2005. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.j2ca.sample.twineball.outbound.commands;

import java.rmi.RemoteException;
import java.util.Vector;
import java.util.logging.Level;

import javax.resource.ResourceException;
import javax.resource.spi.CommException;

import com.ibm.despi.InputCursor;
import com.ibm.j2ca.extension.logging.LogUtilConstants;
import com.ibm.j2ca.extension.metadata.Type;
import com.ibm.wbia.TwineBall.Server.TwineBallException;
import com.ibm.wbia.TwineBall.Server.TwineBallInterface;

/**
 * @author Travis Nelson
 *  
 */
public class TwineBallUpdateCommand extends TwineBallBaseCommand {
    /**
     * @param dataObject
     */
    public TwineBallUpdateCommand() {
        super();
    }

    public void  execute(InputCursor inputObject, Type metadata) throws ResourceException {
        getLogUtils().traceMethodEntrance(TwineBallUpdateCommand.class.getName(), "execute()");
        String entity = objectNaming.getEntityName(metadata);
        String key = objectNaming.getKey(metadata, inputObject);
        setKey(key);
        TwineBallInterface connection = connection = (TwineBallInterface) this.getConnection();
        Vector updateRecord = objectSerializer.toNameValueVector(metadata, inputObject);
        try {
            connection.updateObject(entity, key, updateRecord);
        } catch (RemoteException e) {
            getLogUtils().log(Level.SEVERE, LogUtilConstants.ADAPTER_RBUNDLE, TwineBallCreateCommand.class.getName(), "execute()", "1013", new Object[] { key });
            throw new CommException(e);
        } catch (TwineBallException e) {
            getLogUtils().log(Level.SEVERE, LogUtilConstants.ADAPTER_RBUNDLE, TwineBallCreateCommand.class.getName(), "execute()", "1013", new Object[] { key });
            throw new ResourceException(e);
        }
        this.setEisRepresentation(updateRecord);
        getLogUtils().traceMethodEntrance(TwineBallUpdateCommand.class.getName(), "execute()");
    }
}