/*
 * Licensed Materials - Property of IBM
 * 5724-G93
 * (C) Copyright IBM Corporation 2003. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */

package com.ibm.wbia.TwineBall.Server;

import java.sql.*;

/**
 * @author Jim Haungs
 */
public abstract class DatabaseColumn {
	private DatabaseTable table;
	private String name;
	private int width;

	public DatabaseColumn(DatabaseTable table, String name, int width) {
		this.table = table;
		this.name = name;
		this.width = width;
	}

	public DatabaseTable getTable() {
		return table;
	}

	public String getName() {
		return name;
	}

	public int getWidth() {
		return width;
	}

	public abstract boolean isKey();
	public abstract String getType();
	public abstract String sqlValue(String value);
	public abstract String getValue(ResultSet rs) throws SQLException;
}
