/*
 * Created on Nov 15, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 *
 *
 */
package com.ibm.wbia.TwineBall.Server;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Properties;

import javax.sql.XAConnection;
import javax.sql.XADataSource;
import javax.transaction.xa.XAResource;

/**
 * @author tnelson
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DatabaseConnection {
	private boolean tracing;
	private XADataSource xaDataSource;
	private XAResource xaResource;
	private XAConnection xaConnection;
	/**
	 * @param login
	 * @param password
	 * @param schemaName
	 * @param XA
	 * @param url
	 * @throws TwineBallException
	 * @throws SQLException
	 */
	public Connection getJDBCConnection(String login, String password,
			String schemaName, String url, Properties properties, boolean tracing) throws TwineBallException,
			SQLException {
		Connection connection =null;
		this.tracing=tracing;
		String driver = (String) properties.get("database.driver");
		if (isXA(driver)) {
			connection = setupXAConnection(login, password, schemaName, driver, properties);
		} else {
			connection = DriverManager.getConnection(url, login, password);
			connection.setAutoCommit(false);
		}
		return connection;
	}
	public Connection getJDBCConnection(Properties properties)throws TwineBallException, SQLException{
		Connection connection;
		String userid = (String)properties.get("database.login");
		String password =(String) properties.get("database.password");
		String url = (String)properties.get("database.url");
		String schema = (String)properties.get("database.schema");
		if(schema == null){
			schema = "twineball";
		}
		connection = getJDBCConnection(userid,password,schema,url,properties,true);
		return connection;
	}
	

	private boolean isXA(String driver) throws TwineBallException {
		Class driverClass;
		if (driver == null) {
			throw new TwineBallException(
					"database.driver not defined in properties");
		}
		try {
			driverClass = Class.forName(driver);
		} catch (ClassNotFoundException e) {
			throw new TwineBallException("driver :" + driver
					+ " not found in classpath");
		}
		Class[] interfaces = driverClass.getInterfaces();
		boolean xa = false;
		for (int i = 0; i < interfaces.length; i++) {
			if (interfaces[i].equals(XADataSource.class)) {
				xa = true;
			}
		}
		return xa;
	}

	/**
	 * @param login
	 * @param password
	 * @param schemaName
	 * @param driver
	 * @throws TwineBallException
	 * @throws SQLException
	 */
	private Connection setupXAConnection(String login, String password,
			String schemaName, String driver, Properties properties) throws TwineBallException,
			SQLException {
		Connection connection;
		traceWrite("creating XA DataSource");
		String dbName = (String) properties.get("database.name");
		if (dbName == null) {
			dbName = "TWINE";
		}
		xaDataSource = XADataSourceFactory.createXADataSource(driver, dbName);
		xaConnection = xaDataSource.getXAConnection(login, password);
		traceWrite("Obtaining XA Resource");
		xaResource = xaConnection.getXAResource();
		traceWrite("Obtaining SQL Connection");
		connection = xaConnection.getConnection();
		traceWrite("Turning off autocommit");
		connection.setAutoCommit(false);
		return connection;
	}
	
	private void traceWrite(String traceString) {
		if (tracing)
			System.out.println(traceString);
	}
	

	/**
	 * @return Returns the xaConnection.
	 */
	public XAConnection getXaConnection() {
		return xaConnection;
	}
	/**
	 * @return Returns the xaDataSource.
	 */
	public XADataSource getXaDataSource() {
		return xaDataSource;
	}
	/**
	 * @return Returns the xaResource.
	 */
	public XAResource getXaResource() {
		return xaResource;
	}
}
