/*
 * Licensed Materials - Property of IBM
 * 5724-G93
 * (C) Copyright IBM Corporation 2003. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */

package com.ibm.wbia.TwineBall.Server;

import java.sql.*;

/**
 * @author Jim Haungs
 */

public class DatabaseStringColumn extends DatabaseColumn {
	public DatabaseStringColumn(DatabaseTable table, String name, int width) {
		super(table, name, width);
	}

	public String getType() {
		return "STRING";
	}

	public String sqlValue(String value) {
		if (value.equalsIgnoreCase("null"))
			return value;
		else
			return "'" + value + "'";
	}

	public String getValue(ResultSet rs) throws SQLException {
		return rs.getString(getName());
	}

	public boolean isKey() {
		return false;
	}
}
