package com.ibm.wbia.TwineBall.Server;
import java.rmi.Naming;
import java.rmi.RemoteException;
/**
 * @author tnelson
 *  
 */
public class TwineBallConnectionFactory {
	public TwineBallInterface getConnection(String userid, String password,
			String schemaName, String URL) throws TwineBallException,
			RemoteException {
		TwineBallServerInterface server = getServerImplementation(URL);
		return server.connect(userid, password, schemaName);
	}
	public TwineBallServerInterface getServerImplementation(String URL)
			throws TwineBallException, RemoteException {
		TwineBallServerInterface connectionFactory;
		if (URL == null || URL.equalsIgnoreCase("Cloudscape") || URL.equals("")) {
		    System.out.println("connecting to local Cloudscape instance");
		    connectionFactory = new InProcessConnectionFactory();
		}
		else {
			try {
			    System.out.println("connecting to TwineBallServer via rmi:" + URL);
				connectionFactory = (TwineBallServerInterface) Naming
						.lookup(URL);
			} catch (Exception ex) {
				throw new RemoteException(ex.getMessage());
			}
		}
		return connectionFactory;
	}

}