/*
 * Licensed Materials - Property of IBM
 * 5724-G93
 * (C) Copyright IBM Corporation 2003. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/* DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */

 
package com.ibm.wbia.TwineBall.Server;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Vector;
import javax.transaction.xa.*;

/**
 * @author tnelson
 */
public interface TwineBallInterface extends Remote, TwineBallXA
{

	public void connect(String userid, String pwd, String schemaName) throws RemoteException, TwineBallException;
	public void disconnect() throws RemoteException, TwineBallException;
	public boolean connected() throws RemoteException;
	public int getClientID() throws TwineBallException, RemoteException;
	public String getUserID() throws TwineBallException, RemoteException;	

	public void enableTracing (boolean flag) throws RemoteException;

	public void commit() throws RemoteException, TwineBallException;
	public void rollback() throws RemoteException, TwineBallException;

	public void updateObject(String EntityName, String Key, Vector values) throws RemoteException, TwineBallException; 
	public void deleteObject(String EntityName, String Key) throws RemoteException, TwineBallException; 

	public Vector getObject(String entityName, String Key) throws RemoteException, TwineBallException;
	public Vector findObjectKeys(String entityName) throws RemoteException, TwineBallException;
	public Vector findObjectKeysByContent(String entityName, Vector SearchPairs) throws RemoteException, TwineBallException;
	public Vector findChildKeys(String ParentEntity, String ParentKey, String ChildEntity) throws RemoteException, TwineBallException;

	public Vector getParentNames(String entityName)  throws RemoteException, TwineBallException;
	public Vector getChildNames(String entityName) throws RemoteException, TwineBallException;
	public String insertObject(String entityName, Vector Values) throws RemoteException, TwineBallException; 
	public Vector getEntityNames() throws RemoteException, TwineBallException; 
	public Vector getRootObjects() throws RemoteException, TwineBallException;
	public int    getObjectCount (String tableName) throws RemoteException, TwineBallException;

	public Vector getColumnNames(String entityName) throws RemoteException, TwineBallException; 
	public String getColumnType(String entityName, String columnName) throws RemoteException, TwineBallException; 
	public int    getColumnWidth(String entityName, String columnName) throws RemoteException, TwineBallException;
	public void setSchemaName(String schemaName) throws RemoteException, TwineBallException;

}
