/*
 * Created on Jun 17, 2004
 * 
 * TODO To change the template for this generated file go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
package com.ibm.wbia.TwineBall.Server;
import java.lang.reflect.*;

import javax.naming.*;
import javax.sql.XADataSource;
public class XADataSourceFactory {
	public static XADataSource createXADataSource(String driverName, String databaseName) throws TwineBallException {
		Object driverInstance;
		try {
			Class driverClass = Class.forName(driverName);
			driverInstance = driverClass.newInstance();
			if(databaseName != null){
			Method setDatabaseNameMethod = driverClass.getMethod("setDatabaseName", new Class[]{String.class});
			setDatabaseNameMethod.invoke(driverInstance, new Object[]{databaseName});
			}
		} catch (InvocationTargetException e) {
			throw new TwineBallException(e);
		} catch (ClassNotFoundException e) {
			throw new TwineBallException(e);
		} catch (InstantiationException e) {
			throw new TwineBallException(e);
		} catch (IllegalAccessException e) {
			throw new TwineBallException(e);
		} catch (NoSuchMethodException e) {
			throw new TwineBallException(e);
		}
		return (XADataSource) driverInstance;
	}
	
	public static XADataSource lookupXADataSource(String jndiName) throws TwineBallException{
		XADataSource ds;
		try {
            if ((jndiName == null) || (jndiName.length() == 0)) {
                String msg = "The JNDI name for the data source is invalid.";
                throw new TwineBallException(msg);
            }
            InitialContext ctx = new InitialContext();

            System.out.println("DataSource ds = (DataSource)ctx.lookup("+jndiName+");");
            ds = (XADataSource)ctx.lookup(jndiName);
        }
        catch (NamingException e) {
            System.out.println("NamingException caught: " + e.toString());
            throw new TwineBallException(e);
        }
        return ds;
	}
}