/*
 * Licensed Materials - Property of IBM
 * pidnumber
 * (C) Copyright IBM Corporation 2005. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.j2ca.sample.twineball.mocks;

import javax.resource.spi.work.ExecutionContext;
import javax.resource.spi.work.Work;
import javax.resource.spi.work.WorkEvent;
import javax.resource.spi.work.WorkException;
import javax.resource.spi.work.WorkListener;
import javax.resource.spi.work.WorkManager;


public class MockWorkManager implements WorkManager {

//	WorkListener workListener;
//	public MockWorkManager(WorkListener listener){
//		workListener = listener;
//	}
	public MockWorkManager(){
	}
	
	public void doWork(Work work) throws WorkException {
	    work.run();
	}
	
	public void doWork(Work work, long timeout, ExecutionContext ctx, WorkListener listener) throws WorkException {
        work.run();
    }
	
	public long startWork(Work work) throws WorkException {
        Thread t = new Thread(new WorkThread(work));
        t.start();
        return 0;

	}
	
	public long startWork(Work work, long timeout, ExecutionContext ctx,
			WorkListener listener) throws WorkException {
        if (listener != null) {
            listener.workAccepted(new WorkEvent(this, WorkEvent.WORK_ACCEPTED, work, null));
        }
        Thread t = new Thread(new WorkThread(work, listener));
        t.start();
        return 0;
	}
	
	
	public void scheduleWork(Work work) throws WorkException {
        Thread t = new Thread(new WorkThread(work));
        t.start();
	}
	
	public void scheduleWork(Work work, long timeout, ExecutionContext ctx,
			WorkListener listener) throws WorkException {
        if (listener != null) {
            listener.workAccepted(new WorkEvent(this, WorkEvent.WORK_ACCEPTED, work, null));
        }
        Thread t = new Thread(new WorkThread(work, listener));
        t.start();
    }
}
