/*
 * Licensed Materials - Property of IBM
 * pidnumber
 * (C) Copyright IBM Corporation 2005. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.j2ca.sample.twineball.mocks;

import java.util.Vector;
import javax.resource.spi.work.*;

public class WorkThread implements Runnable {
    private static Vector currentThreads = new Vector();

    WorkListener listener;

    Work work;

    public WorkThread(Work work) {
        this(work,null);
    }
    
    public WorkThread(Work work, WorkListener listener) {
        this.work = work;
        this.listener = listener;
        currentThreads.add(work);
    }

    public void run() {
        if (listener != null) {
            listener.workStarted(new WorkEvent(this, WorkEvent.WORK_STARTED, work, null));
        }
        try {
            work.run();
        } catch (Exception e) {
            e.printStackTrace();
        }
        currentThreads.remove(work);

        if (listener != null) {
            listener.workCompleted(new WorkEvent(this, WorkEvent.WORK_COMPLETED, work, null));
        }
    }
}
