/*
 * Licensed Materials - Property of IBM
 * pidnumber
 * (C) Copyright IBM Corporation 2005. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.j2ca.sample.twineball.outbound;

import java.util.Vector;
import junit.framework.TestCase;
import com.ibm.j2ca.sample.twineball.ObjectNaming;
import com.ibm.j2ca.sample.twineball.ObjectSerializer;
import com.ibm.j2ca.sample.twineball.TwineBallResourceAdapter;
import com.ibm.j2ca.sample.twineball.mocks.MockBootstrapContext;
import com.ibm.j2ca.sample.twineball.mocks.SDOBuilder;
import commonj.sdo.DataObject;

public class ObjectSerializerTest extends TestCase {

	ObjectSerializer objectSerializer;
	SDOBuilder builder;
	
	protected void setUp() throws Exception {
	    TwineBallResourceAdapter ra = new TwineBallResourceAdapter();
	    ra.start(new MockBootstrapContext());
		objectSerializer = new ObjectSerializer(new ObjectNaming(ra));
		builder = new SDOBuilder();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testToNameValueVector() throws Exception {
		DataObject wrapperObject = new SDOBuilder().createCustomer("0001");
		DataObject dataObject = builder.getCustomer(wrapperObject);
		dataObject.setString("Primarykey", "00001");
		dataObject.setString("Firstname","travis");
		dataObject.setString("Lastname","nelson");
		Vector nameValueVector = objectSerializer.toNameValueVector(dataObject);
		assertTrue(nameValueVector.get(0).equals("PRIMARYKEY=00001"));	
		assertTrue(nameValueVector.get(1).equals("FIRSTNAME=travis"));
		assertTrue(nameValueVector.get(2).equals("LASTNAME=nelson"));
	}
}
